<!-- HTML header for doxygen 1.8.9.1-->
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.11"/>
<title>OpenThread: src/core/net/icmp6.hpp Source File</title>
<link href="../../tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../jquery.js"></script>
<script type="text/javascript" src="../../dynsections.js"></script>
<link href="../../navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../resize.js"></script>
<script type="text/javascript" src="../../navtreedata.js"></script>
<script type="text/javascript" src="../../navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
  $(window).load(resizeHeight);
</script>
<link href="../../search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../search/searchdata.js"></script>
<script type="text/javascript" src="../../search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { init_search(); });
</script>
<link href="../../doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="../../Open-Thread-Logo-200x42.png"/></td>
  <td style="padding-left: 0.5em;">
   <div id="projectname">
   &#160;<span id="projectnumber">gddd0704</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.11 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "../../search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="../../index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="../../modules.html"><span>Modules</span></a></li>
      <li><a href="../../namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="../../annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="../../files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="../../search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="../../search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="../../files.html"><span>File&#160;List</span></a></li>
      <li><a href="../../globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('d0/dba/icmp6_8hpp_source.html','../../');});
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">icmp6.hpp</div>  </div>
</div><!--header-->
<div class="contents">
<a href="../../d0/dba/icmp6_8hpp.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">/*</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment"> *  Copyright (c) 2016, The OpenThread Authors.</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment"> *  All rights reserved.</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="comment"> *  Redistribution and use in source and binary forms, with or without</span></div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="comment"> *  modification, are permitted provided that the following conditions are met:</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="comment"> *  1. Redistributions of source code must retain the above copyright</span></div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="comment"> *     notice, this list of conditions and the following disclaimer.</span></div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="comment"> *  2. Redistributions in binary form must reproduce the above copyright</span></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="comment"> *     notice, this list of conditions and the following disclaimer in the</span></div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="comment"> *     documentation and/or other materials provided with the distribution.</span></div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="comment"> *  3. Neither the name of the copyright holder nor the</span></div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="comment"> *     names of its contributors may be used to endorse or promote products</span></div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="comment"> *     derived from this software without specific prior written permission.</span></div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="comment"> *  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS &quot;AS IS&quot;</span></div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="comment"> *  AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE</span></div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;<span class="comment"> *  IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE</span></div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="comment"> *  ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE</span></div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;<span class="comment"> *  LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR</span></div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;<span class="comment"> *  CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF</span></div><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;<span class="comment"> *  SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS</span></div><div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;<span class="comment"> *  INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN</span></div><div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;<span class="comment"> *  CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)</span></div><div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;<span class="comment"> *  ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE</span></div><div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;<span class="comment"> *  POSSIBILITY OF SUCH DAMAGE.</span></div><div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;<span class="comment"> */</span></div><div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;</div><div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;<span class="preprocessor">#ifndef ICMP6_HPP_</span></div><div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;<span class="preprocessor">#define ICMP6_HPP_</span></div><div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;</div><div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="../../df/d57/encoding_8hpp.html">common/encoding.hpp</a>&gt;</span></div><div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="../../db/d51/ip6__headers_8hpp.html">net/ip6_headers.hpp</a>&gt;</span></div><div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;</div><div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;<span class="keyword">using</span> Thread::Encoding::BigEndian::HostSwap16;</div><div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;</div><div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;<span class="keyword">namespace </span><a class="code" href="../../d9/d00/namespaceThread.html">Thread</a> {</div><div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;<span class="keyword">namespace </span>Ip6 {</div><div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;</div><div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;<span class="keyword">enum</span></div><div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;{</div><div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;    kIcmp6DataSize = 4,</div><div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;};</div><div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;</div><div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;<a class="code" href="../../d7/da1/group__toolchain.html#gaba6ad63129c3a790957a9b149a65891b">OT_TOOL_PACKED_BEGIN</a></div><div class="line"><a name="l00065"></a><span class="lineno"><a class="line" href="../../d4/d90/structThread_1_1Ip6_1_1IcmpHeaderPoD.html">   65</a></span>&#160;<span class="keyword">struct </span><a class="code" href="../../d4/d90/structThread_1_1Ip6_1_1IcmpHeaderPoD.html">IcmpHeaderPoD</a></div><div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;{</div><div class="line"><a name="l00067"></a><span class="lineno"><a class="line" href="../../d4/d90/structThread_1_1Ip6_1_1IcmpHeaderPoD.html#a1d3fc65dcc6b226759c2da5eb1f7422b">   67</a></span>&#160;    uint8_t      <a class="code" href="../../d4/d90/structThread_1_1Ip6_1_1IcmpHeaderPoD.html#a1d3fc65dcc6b226759c2da5eb1f7422b">mType</a>;      </div><div class="line"><a name="l00068"></a><span class="lineno"><a class="line" href="../../d4/d90/structThread_1_1Ip6_1_1IcmpHeaderPoD.html#a9340c0b6398ee6f072f20a6dac7983ce">   68</a></span>&#160;    uint8_t      <a class="code" href="../../d4/d90/structThread_1_1Ip6_1_1IcmpHeaderPoD.html#a9340c0b6398ee6f072f20a6dac7983ce">mCode</a>;      </div><div class="line"><a name="l00069"></a><span class="lineno"><a class="line" href="../../d4/d90/structThread_1_1Ip6_1_1IcmpHeaderPoD.html#a1f9efcf2fc78902fe8dd520ae05fcea8">   69</a></span>&#160;    uint16_t     <a class="code" href="../../d4/d90/structThread_1_1Ip6_1_1IcmpHeaderPoD.html#a1f9efcf2fc78902fe8dd520ae05fcea8">mChecksum</a>;  </div><div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;    <span class="keyword">union</span></div><div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;    {</div><div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;        uint8_t  m8[kIcmp6DataSize / <span class="keyword">sizeof</span>(uint8_t)];</div><div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;        uint16_t m16[kIcmp6DataSize / <span class="keyword">sizeof</span>(uint16_t)];</div><div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;        uint32_t m32[kIcmp6DataSize / <span class="keyword">sizeof</span>(uint32_t)];</div><div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;    } <a class="code" href="../../d4/d90/structThread_1_1Ip6_1_1IcmpHeaderPoD.html#a7964bba0309c888464566a609e566210">mData</a>;                 </div><div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;} <a class="code" href="../../d7/da1/group__toolchain.html#gacf07d7a4a2ea6d0cc3426234565fcb7b">OT_TOOL_PACKED_END</a>;</div><div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;</div><div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;<a class="code" href="../../d7/da1/group__toolchain.html#gaba6ad63129c3a790957a9b149a65891b">OT_TOOL_PACKED_BEGIN</a></div><div class="line"><a name="l00083"></a><span class="lineno"><a class="line" href="../../d2/de0/classThread_1_1Ip6_1_1IcmpHeader.html">   83</a></span>&#160;<span class="keyword">class </span><a class="code" href="../../d2/de0/classThread_1_1Ip6_1_1IcmpHeader.html">IcmpHeader</a>: <span class="keyword">private</span> <a class="code" href="../../d4/d90/structThread_1_1Ip6_1_1IcmpHeaderPoD.html">IcmpHeaderPoD</a></div><div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;{</div><div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;<span class="keyword">public</span>:</div><div class="line"><a name="l00090"></a><span class="lineno"><a class="line" href="../../d2/de0/classThread_1_1Ip6_1_1IcmpHeader.html#aef3c7da70d4b476884163996141a481b">   90</a></span>&#160;    <span class="keywordtype">void</span> <a class="code" href="../../d2/de0/classThread_1_1Ip6_1_1IcmpHeader.html#aef3c7da70d4b476884163996141a481b">Init</a>() { <a class="code" href="../../d4/d90/structThread_1_1Ip6_1_1IcmpHeaderPoD.html#a1d3fc65dcc6b226759c2da5eb1f7422b">mType</a> = 0; <a class="code" href="../../d4/d90/structThread_1_1Ip6_1_1IcmpHeaderPoD.html#a9340c0b6398ee6f072f20a6dac7983ce">mCode</a> = 0; <a class="code" href="../../d4/d90/structThread_1_1Ip6_1_1IcmpHeaderPoD.html#a1f9efcf2fc78902fe8dd520ae05fcea8">mChecksum</a> = 0; <a class="code" href="../../d4/d90/structThread_1_1Ip6_1_1IcmpHeaderPoD.html#a7964bba0309c888464566a609e566210">mData</a>.m32[0] = 0; }</div><div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;</div><div class="line"><a name="l00096"></a><span class="lineno"><a class="line" href="../../d2/de0/classThread_1_1Ip6_1_1IcmpHeader.html#a9939caba0638b495eb7a74bfc76120fb">   96</a></span>&#160;    <span class="keyword">enum</span> <a class="code" href="../../d2/de0/classThread_1_1Ip6_1_1IcmpHeader.html#a9939caba0638b495eb7a74bfc76120fb">Type</a></div><div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;    {</div><div class="line"><a name="l00098"></a><span class="lineno"><a class="line" href="../../d2/de0/classThread_1_1Ip6_1_1IcmpHeader.html#a9939caba0638b495eb7a74bfc76120fba7a7b44dcfeec8258930d1837f5e94ee1">   98</a></span>&#160;        kTypeDstUnreach  = 0,     </div><div class="line"><a name="l00099"></a><span class="lineno"><a class="line" href="../../d2/de0/classThread_1_1Ip6_1_1IcmpHeader.html#a9939caba0638b495eb7a74bfc76120fbae7039b73ba8a6d010b84f9f1fdecfb31">   99</a></span>&#160;        kTypeEchoRequest = 128,   </div><div class="line"><a name="l00100"></a><span class="lineno"><a class="line" href="../../d2/de0/classThread_1_1Ip6_1_1IcmpHeader.html#a9939caba0638b495eb7a74bfc76120fba8f70e7d366dd6a8a2334d4d1d31ff83f">  100</a></span>&#160;        kTypeEchoReply   = 129,   </div><div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160;    };</div><div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;</div><div class="line"><a name="l00109"></a><span class="lineno"><a class="line" href="../../d2/de0/classThread_1_1Ip6_1_1IcmpHeader.html#ad51a0764c274f4d82fd23a99fa1e6800">  109</a></span>&#160;    <a class="code" href="../../d2/de0/classThread_1_1Ip6_1_1IcmpHeader.html#a9939caba0638b495eb7a74bfc76120fb">Type</a> <a class="code" href="../../d2/de0/classThread_1_1Ip6_1_1IcmpHeader.html#ad51a0764c274f4d82fd23a99fa1e6800">GetType</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <span class="keyword">static_cast&lt;</span><a class="code" href="../../d2/de0/classThread_1_1Ip6_1_1IcmpHeader.html#a9939caba0638b495eb7a74bfc76120fb">Type</a><span class="keyword">&gt;</span>(<a class="code" href="../../d4/d90/structThread_1_1Ip6_1_1IcmpHeaderPoD.html#a1d3fc65dcc6b226759c2da5eb1f7422b">mType</a>); }</div><div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160;</div><div class="line"><a name="l00117"></a><span class="lineno"><a class="line" href="../../d2/de0/classThread_1_1Ip6_1_1IcmpHeader.html#a8609c3839e26f6ab4625159bf9c35873">  117</a></span>&#160;    <span class="keywordtype">void</span> <a class="code" href="../../d2/de0/classThread_1_1Ip6_1_1IcmpHeader.html#a8609c3839e26f6ab4625159bf9c35873">SetType</a>(<a class="code" href="../../d2/de0/classThread_1_1Ip6_1_1IcmpHeader.html#a9939caba0638b495eb7a74bfc76120fb">Type</a> aType) { <a class="code" href="../../d4/d90/structThread_1_1Ip6_1_1IcmpHeaderPoD.html#a1d3fc65dcc6b226759c2da5eb1f7422b">mType</a> = <span class="keyword">static_cast&lt;</span>uint8_t<span class="keyword">&gt;</span>(aType); }</div><div class="line"><a name="l00118"></a><span class="lineno">  118</span>&#160;</div><div class="line"><a name="l00123"></a><span class="lineno"><a class="line" href="../../d2/de0/classThread_1_1Ip6_1_1IcmpHeader.html#ac2a08e3b5fc1a6cb6a1f2dead5403e02">  123</a></span>&#160;    <span class="keyword">enum</span> <a class="code" href="../../d2/de0/classThread_1_1Ip6_1_1IcmpHeader.html#ac2a08e3b5fc1a6cb6a1f2dead5403e02">Code</a></div><div class="line"><a name="l00124"></a><span class="lineno">  124</span>&#160;    {</div><div class="line"><a name="l00125"></a><span class="lineno"><a class="line" href="../../d2/de0/classThread_1_1Ip6_1_1IcmpHeader.html#ac2a08e3b5fc1a6cb6a1f2dead5403e02a8e8fca8bc66b19a72d0a919c07153022">  125</a></span>&#160;        kCodeDstUnreachNoRoute = 0,  </div><div class="line"><a name="l00126"></a><span class="lineno">  126</span>&#160;    };</div><div class="line"><a name="l00127"></a><span class="lineno">  127</span>&#160;</div><div class="line"><a name="l00134"></a><span class="lineno"><a class="line" href="../../d2/de0/classThread_1_1Ip6_1_1IcmpHeader.html#a9f4d328694de528770bce839e920f1ff">  134</a></span>&#160;    <a class="code" href="../../d2/de0/classThread_1_1Ip6_1_1IcmpHeader.html#ac2a08e3b5fc1a6cb6a1f2dead5403e02">Code</a> <a class="code" href="../../d2/de0/classThread_1_1Ip6_1_1IcmpHeader.html#a9f4d328694de528770bce839e920f1ff">GetCode</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <span class="keyword">static_cast&lt;</span><a class="code" href="../../d2/de0/classThread_1_1Ip6_1_1IcmpHeader.html#ac2a08e3b5fc1a6cb6a1f2dead5403e02">Code</a><span class="keyword">&gt;</span>(<a class="code" href="../../d4/d90/structThread_1_1Ip6_1_1IcmpHeaderPoD.html#a9340c0b6398ee6f072f20a6dac7983ce">mCode</a>); }</div><div class="line"><a name="l00135"></a><span class="lineno">  135</span>&#160;</div><div class="line"><a name="l00141"></a><span class="lineno"><a class="line" href="../../d2/de0/classThread_1_1Ip6_1_1IcmpHeader.html#af871471b8d84ee757ecd81483944373e">  141</a></span>&#160;    <span class="keywordtype">void</span> <a class="code" href="../../d2/de0/classThread_1_1Ip6_1_1IcmpHeader.html#af871471b8d84ee757ecd81483944373e">SetCode</a>(<a class="code" href="../../d2/de0/classThread_1_1Ip6_1_1IcmpHeader.html#ac2a08e3b5fc1a6cb6a1f2dead5403e02">Code</a> aCode) { <a class="code" href="../../d4/d90/structThread_1_1Ip6_1_1IcmpHeaderPoD.html#a9340c0b6398ee6f072f20a6dac7983ce">mCode</a> = <span class="keyword">static_cast&lt;</span>uint8_t<span class="keyword">&gt;</span>(aCode); }</div><div class="line"><a name="l00142"></a><span class="lineno">  142</span>&#160;</div><div class="line"><a name="l00149"></a><span class="lineno"><a class="line" href="../../d2/de0/classThread_1_1Ip6_1_1IcmpHeader.html#a027f2899206b74dad24b25d164163d37">  149</a></span>&#160;    uint16_t <a class="code" href="../../d2/de0/classThread_1_1Ip6_1_1IcmpHeader.html#a027f2899206b74dad24b25d164163d37">GetChecksum</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> HostSwap16(<a class="code" href="../../d4/d90/structThread_1_1Ip6_1_1IcmpHeaderPoD.html#a1f9efcf2fc78902fe8dd520ae05fcea8">mChecksum</a>); }</div><div class="line"><a name="l00150"></a><span class="lineno">  150</span>&#160;</div><div class="line"><a name="l00157"></a><span class="lineno"><a class="line" href="../../d2/de0/classThread_1_1Ip6_1_1IcmpHeader.html#a6e2af997154e86c8bb48118623c4ea8b">  157</a></span>&#160;    <span class="keywordtype">void</span> <a class="code" href="../../d2/de0/classThread_1_1Ip6_1_1IcmpHeader.html#a6e2af997154e86c8bb48118623c4ea8b">SetChecksum</a>(uint16_t aChecksum) { <a class="code" href="../../d4/d90/structThread_1_1Ip6_1_1IcmpHeaderPoD.html#a1f9efcf2fc78902fe8dd520ae05fcea8">mChecksum</a> = HostSwap16(aChecksum); }</div><div class="line"><a name="l00158"></a><span class="lineno">  158</span>&#160;</div><div class="line"><a name="l00165"></a><span class="lineno"><a class="line" href="../../d2/de0/classThread_1_1Ip6_1_1IcmpHeader.html#a85cd947dd4eb8f5ba2c2fbd8a09a564d">  165</a></span>&#160;    uint16_t <a class="code" href="../../d2/de0/classThread_1_1Ip6_1_1IcmpHeader.html#a85cd947dd4eb8f5ba2c2fbd8a09a564d">GetId</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> HostSwap16(<a class="code" href="../../d4/d90/structThread_1_1Ip6_1_1IcmpHeaderPoD.html#a7964bba0309c888464566a609e566210">mData</a>.m16[0]); }</div><div class="line"><a name="l00166"></a><span class="lineno">  166</span>&#160;</div><div class="line"><a name="l00173"></a><span class="lineno"><a class="line" href="../../d2/de0/classThread_1_1Ip6_1_1IcmpHeader.html#ad2fc6f420d783b7185bc11906d9d7bcf">  173</a></span>&#160;    <span class="keywordtype">void</span> <a class="code" href="../../d2/de0/classThread_1_1Ip6_1_1IcmpHeader.html#ad2fc6f420d783b7185bc11906d9d7bcf">SetId</a>(uint16_t aId) { <a class="code" href="../../d4/d90/structThread_1_1Ip6_1_1IcmpHeaderPoD.html#a7964bba0309c888464566a609e566210">mData</a>.m16[0] = HostSwap16(aId); }</div><div class="line"><a name="l00174"></a><span class="lineno">  174</span>&#160;</div><div class="line"><a name="l00181"></a><span class="lineno"><a class="line" href="../../d2/de0/classThread_1_1Ip6_1_1IcmpHeader.html#a036101271b93c88ed1cc7038c45bd163">  181</a></span>&#160;    uint16_t <a class="code" href="../../d2/de0/classThread_1_1Ip6_1_1IcmpHeader.html#a036101271b93c88ed1cc7038c45bd163">GetSequence</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> HostSwap16(<a class="code" href="../../d4/d90/structThread_1_1Ip6_1_1IcmpHeaderPoD.html#a7964bba0309c888464566a609e566210">mData</a>.m16[1]); }</div><div class="line"><a name="l00182"></a><span class="lineno">  182</span>&#160;</div><div class="line"><a name="l00189"></a><span class="lineno"><a class="line" href="../../d2/de0/classThread_1_1Ip6_1_1IcmpHeader.html#a275fba913f341b9d0e7018b5e02e072a">  189</a></span>&#160;    <span class="keywordtype">void</span> <a class="code" href="../../d2/de0/classThread_1_1Ip6_1_1IcmpHeader.html#a275fba913f341b9d0e7018b5e02e072a">SetSequence</a>(uint16_t aSequence) { <a class="code" href="../../d4/d90/structThread_1_1Ip6_1_1IcmpHeaderPoD.html#a7964bba0309c888464566a609e566210">mData</a>.m16[1] = HostSwap16(aSequence); }</div><div class="line"><a name="l00190"></a><span class="lineno">  190</span>&#160;</div><div class="line"><a name="l00197"></a><span class="lineno"><a class="line" href="../../d2/de0/classThread_1_1Ip6_1_1IcmpHeader.html#aeda92e625e305e9021bc18ccadfba4ca">  197</a></span>&#160;    <span class="keyword">static</span> uint8_t <a class="code" href="../../d2/de0/classThread_1_1Ip6_1_1IcmpHeader.html#aeda92e625e305e9021bc18ccadfba4ca">GetChecksumOffset</a>() { <span class="keywordflow">return</span> offsetof(<a class="code" href="../../d4/d90/structThread_1_1Ip6_1_1IcmpHeaderPoD.html">IcmpHeaderPoD</a>, <a class="code" href="../../d4/d90/structThread_1_1Ip6_1_1IcmpHeaderPoD.html#a1f9efcf2fc78902fe8dd520ae05fcea8">mChecksum</a>); }</div><div class="line"><a name="l00198"></a><span class="lineno">  198</span>&#160;</div><div class="line"><a name="l00205"></a><span class="lineno"><a class="line" href="../../d2/de0/classThread_1_1Ip6_1_1IcmpHeader.html#a500827c838059c96ab7c1aea787a74fb">  205</a></span>&#160;    <span class="keyword">static</span> uint8_t <a class="code" href="../../d2/de0/classThread_1_1Ip6_1_1IcmpHeader.html#a500827c838059c96ab7c1aea787a74fb">GetDataOffset</a>() { <span class="keywordflow">return</span> offsetof(<a class="code" href="../../d4/d90/structThread_1_1Ip6_1_1IcmpHeaderPoD.html">IcmpHeaderPoD</a>, <a class="code" href="../../d4/d90/structThread_1_1Ip6_1_1IcmpHeaderPoD.html#a7964bba0309c888464566a609e566210">mData</a>); }</div><div class="line"><a name="l00206"></a><span class="lineno">  206</span>&#160;</div><div class="line"><a name="l00207"></a><span class="lineno">  207</span>&#160;} <a class="code" href="../../d7/da1/group__toolchain.html#gacf07d7a4a2ea6d0cc3426234565fcb7b">OT_TOOL_PACKED_END</a>;</div><div class="line"><a name="l00208"></a><span class="lineno">  208</span>&#160;</div><div class="line"><a name="l00213"></a><span class="lineno"><a class="line" href="../../da/dff/classThread_1_1Ip6_1_1IcmpHandler.html">  213</a></span>&#160;<span class="keyword">class </span><a class="code" href="../../da/dff/classThread_1_1Ip6_1_1IcmpHandler.html">IcmpHandler</a></div><div class="line"><a name="l00214"></a><span class="lineno">  214</span>&#160;{</div><div class="line"><a name="l00215"></a><span class="lineno">  215</span>&#160;    <span class="keyword">friend</span> <span class="keyword">class </span><a class="code" href="../../da/dd7/classThread_1_1Ip6_1_1Icmp.html">Icmp</a>;</div><div class="line"><a name="l00216"></a><span class="lineno">  216</span>&#160;</div><div class="line"><a name="l00217"></a><span class="lineno">  217</span>&#160;<span class="keyword">public</span>:</div><div class="line"><a name="l00227"></a><span class="lineno"><a class="line" href="../../da/dff/classThread_1_1Ip6_1_1IcmpHandler.html#a29e4de7922e90efb1c9f2195a7e4cf3c">  227</a></span>&#160;    <span class="keyword">typedef</span> void (*DstUnreachHandler)(<span class="keywordtype">void</span> *aContext, <a class="code" href="../../dc/d3c/classThread_1_1Message.html">Message</a> &amp;aMesage, <span class="keyword">const</span> <a class="code" href="../../da/d46/classThread_1_1Ip6_1_1MessageInfo.html">MessageInfo</a> &amp;aMessageInfo,</div><div class="line"><a name="l00228"></a><span class="lineno">  228</span>&#160;                                      <span class="keyword">const</span> <a class="code" href="../../d2/de0/classThread_1_1Ip6_1_1IcmpHeader.html">IcmpHeader</a> &amp;aIcmpHeader);</div><div class="line"><a name="l00229"></a><span class="lineno">  229</span>&#160;</div><div class="line"><a name="l00238"></a><span class="lineno"><a class="line" href="../../da/dff/classThread_1_1Ip6_1_1IcmpHandler.html#a0d479f55838901ccb5b1ebd383e20db4">  238</a></span>&#160;    <a class="code" href="../../da/dff/classThread_1_1Ip6_1_1IcmpHandler.html#a0d479f55838901ccb5b1ebd383e20db4">IcmpHandler</a>(DstUnreachHandler aDstUnreachHandler, <span class="keywordtype">void</span> *aContext) {</div><div class="line"><a name="l00239"></a><span class="lineno">  239</span>&#160;        mDstUnreachHandler = aDstUnreachHandler;</div><div class="line"><a name="l00240"></a><span class="lineno">  240</span>&#160;        mContext = aContext;</div><div class="line"><a name="l00241"></a><span class="lineno">  241</span>&#160;        mNext = NULL;</div><div class="line"><a name="l00242"></a><span class="lineno">  242</span>&#160;    }</div><div class="line"><a name="l00243"></a><span class="lineno">  243</span>&#160;</div><div class="line"><a name="l00244"></a><span class="lineno">  244</span>&#160;<span class="keyword">private</span>:</div><div class="line"><a name="l00245"></a><span class="lineno">  245</span>&#160;    <span class="keywordtype">void</span> HandleDstUnreach(<a class="code" href="../../dc/d3c/classThread_1_1Message.html">Message</a> &amp;message, <span class="keyword">const</span> <a class="code" href="../../da/d46/classThread_1_1Ip6_1_1MessageInfo.html">MessageInfo</a> &amp;messageInfo, <span class="keyword">const</span> <a class="code" href="../../d2/de0/classThread_1_1Ip6_1_1IcmpHeader.html">IcmpHeader</a> &amp;icmp6Header) {</div><div class="line"><a name="l00246"></a><span class="lineno">  246</span>&#160;        mDstUnreachHandler(mContext, message, messageInfo, icmp6Header);</div><div class="line"><a name="l00247"></a><span class="lineno">  247</span>&#160;    }</div><div class="line"><a name="l00248"></a><span class="lineno">  248</span>&#160;</div><div class="line"><a name="l00249"></a><span class="lineno">  249</span>&#160;    DstUnreachHandler    mDstUnreachHandler;</div><div class="line"><a name="l00250"></a><span class="lineno">  250</span>&#160;    <span class="keywordtype">void</span>                *mContext;</div><div class="line"><a name="l00251"></a><span class="lineno">  251</span>&#160;    <a class="code" href="../../da/dff/classThread_1_1Ip6_1_1IcmpHandler.html">IcmpHandler</a>         *mNext;</div><div class="line"><a name="l00252"></a><span class="lineno">  252</span>&#160;};</div><div class="line"><a name="l00253"></a><span class="lineno">  253</span>&#160;</div><div class="line"><a name="l00258"></a><span class="lineno"><a class="line" href="../../da/dd7/classThread_1_1Ip6_1_1Icmp.html">  258</a></span>&#160;<span class="keyword">class </span><a class="code" href="../../da/dd7/classThread_1_1Ip6_1_1Icmp.html">Icmp</a></div><div class="line"><a name="l00259"></a><span class="lineno">  259</span>&#160;{</div><div class="line"><a name="l00260"></a><span class="lineno">  260</span>&#160;<span class="keyword">public</span>:</div><div class="line"><a name="l00267"></a><span class="lineno">  267</span>&#160;    <a class="code" href="../../da/dd7/classThread_1_1Ip6_1_1Icmp.html">Icmp</a>(<a class="code" href="../../d3/d05/classThread_1_1Ip6_1_1Ip6.html">Ip6</a> &amp;aIp6);</div><div class="line"><a name="l00268"></a><span class="lineno">  268</span>&#160;</div><div class="line"><a name="l00277"></a><span class="lineno">  277</span>&#160;    <a class="code" href="../../dc/d3c/classThread_1_1Message.html">Message</a> *NewMessage(uint16_t aReserved);</div><div class="line"><a name="l00278"></a><span class="lineno">  278</span>&#160;</div><div class="line"><a name="l00288"></a><span class="lineno">  288</span>&#160;    <a class="code" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a> RegisterCallbacks(<a class="code" href="../../da/dff/classThread_1_1Ip6_1_1IcmpHandler.html">IcmpHandler</a> &amp;aHandler);</div><div class="line"><a name="l00289"></a><span class="lineno">  289</span>&#160;</div><div class="line"><a name="l00298"></a><span class="lineno"><a class="line" href="../../da/dd7/classThread_1_1Ip6_1_1Icmp.html#a1576fd382cb2f92f9b48f0b78c671a62">  298</a></span>&#160;    <span class="keyword">typedef</span> void (*EchoReplyHandler)(<span class="keywordtype">void</span> *aContext, <a class="code" href="../../dc/d3c/classThread_1_1Message.html">Message</a> &amp;aMessage, <span class="keyword">const</span> <a class="code" href="../../da/d46/classThread_1_1Ip6_1_1MessageInfo.html">MessageInfo</a> &amp;aMessageInfo);</div><div class="line"><a name="l00299"></a><span class="lineno">  299</span>&#160;</div><div class="line"><a name="l00307"></a><span class="lineno">  307</span>&#160;    <span class="keywordtype">void</span> SetEchoReplyHandler(EchoReplyHandler aHandler, <span class="keywordtype">void</span> *aContext);</div><div class="line"><a name="l00308"></a><span class="lineno">  308</span>&#160;</div><div class="line"><a name="l00319"></a><span class="lineno">  319</span>&#160;    <a class="code" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a> SendEchoRequest(<a class="code" href="../../dc/d3c/classThread_1_1Message.html">Message</a> &amp;aMessage, <span class="keyword">const</span> <a class="code" href="../../da/d46/classThread_1_1Ip6_1_1MessageInfo.html">MessageInfo</a> &amp;aMessageInfo);</div><div class="line"><a name="l00320"></a><span class="lineno">  320</span>&#160;</div><div class="line"><a name="l00333"></a><span class="lineno">  333</span>&#160;    <a class="code" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a> SendError(<span class="keyword">const</span> <a class="code" href="../../d9/db1/classThread_1_1Ip6_1_1Address.html">Address</a> &amp;aDestination, <a class="code" href="../../d2/de0/classThread_1_1Ip6_1_1IcmpHeader.html#a9939caba0638b495eb7a74bfc76120fb">IcmpHeader::Type</a> aType, <a class="code" href="../../d2/de0/classThread_1_1Ip6_1_1IcmpHeader.html#ac2a08e3b5fc1a6cb6a1f2dead5403e02">IcmpHeader::Code</a> aCode,</div><div class="line"><a name="l00334"></a><span class="lineno">  334</span>&#160;                          <span class="keyword">const</span> <a class="code" href="../../d8/d6e/classThread_1_1Ip6_1_1Header.html">Header</a> &amp;aHeader);</div><div class="line"><a name="l00335"></a><span class="lineno">  335</span>&#160;</div><div class="line"><a name="l00347"></a><span class="lineno">  347</span>&#160;    <a class="code" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a> HandleMessage(<a class="code" href="../../dc/d3c/classThread_1_1Message.html">Message</a> &amp;aMessage, <a class="code" href="../../da/d46/classThread_1_1Ip6_1_1MessageInfo.html">MessageInfo</a> &amp;aMessageInfo);</div><div class="line"><a name="l00348"></a><span class="lineno">  348</span>&#160;</div><div class="line"><a name="l00359"></a><span class="lineno">  359</span>&#160;    <a class="code" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a> UpdateChecksum(<a class="code" href="../../dc/d3c/classThread_1_1Message.html">Message</a> &amp;aMessage, uint16_t aPseudoHeaderChecksum);</div><div class="line"><a name="l00360"></a><span class="lineno">  360</span>&#160;</div><div class="line"><a name="l00368"></a><span class="lineno">  368</span>&#160;    <span class="keywordtype">bool</span> IsEchoEnabled(<span class="keywordtype">void</span>);</div><div class="line"><a name="l00369"></a><span class="lineno">  369</span>&#160;</div><div class="line"><a name="l00376"></a><span class="lineno">  376</span>&#160;    <span class="keywordtype">void</span> SetEchoEnabled(<span class="keywordtype">bool</span> aEnabled);</div><div class="line"><a name="l00377"></a><span class="lineno">  377</span>&#160;</div><div class="line"><a name="l00378"></a><span class="lineno">  378</span>&#160;<span class="keyword">private</span>:</div><div class="line"><a name="l00379"></a><span class="lineno">  379</span>&#160;    <a class="code" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a> HandleDstUnreach(<a class="code" href="../../dc/d3c/classThread_1_1Message.html">Message</a> &amp;aMessage, <span class="keyword">const</span> <a class="code" href="../../da/d46/classThread_1_1Ip6_1_1MessageInfo.html">MessageInfo</a> &amp;aMessageInfo, <span class="keyword">const</span> <a class="code" href="../../d2/de0/classThread_1_1Ip6_1_1IcmpHeader.html">IcmpHeader</a> &amp;aIcmpHeader);</div><div class="line"><a name="l00380"></a><span class="lineno">  380</span>&#160;    <a class="code" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a> HandleEchoRequest(<a class="code" href="../../dc/d3c/classThread_1_1Message.html">Message</a> &amp;aMessage, <span class="keyword">const</span> <a class="code" href="../../da/d46/classThread_1_1Ip6_1_1MessageInfo.html">MessageInfo</a> &amp;aMessageInfo);</div><div class="line"><a name="l00381"></a><span class="lineno">  381</span>&#160;    <a class="code" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a> HandleEchoReply(<a class="code" href="../../dc/d3c/classThread_1_1Message.html">Message</a> &amp;aMessage, <span class="keyword">const</span> <a class="code" href="../../da/d46/classThread_1_1Ip6_1_1MessageInfo.html">MessageInfo</a> &amp;aMessageInfo);</div><div class="line"><a name="l00382"></a><span class="lineno">  382</span>&#160;</div><div class="line"><a name="l00383"></a><span class="lineno">  383</span>&#160;    <a class="code" href="../../da/dff/classThread_1_1Ip6_1_1IcmpHandler.html">IcmpHandler</a> *mHandlers;</div><div class="line"><a name="l00384"></a><span class="lineno">  384</span>&#160;</div><div class="line"><a name="l00385"></a><span class="lineno">  385</span>&#160;    uint16_t mEchoSequence;</div><div class="line"><a name="l00386"></a><span class="lineno">  386</span>&#160;    EchoReplyHandler mEchoReplyHandler;</div><div class="line"><a name="l00387"></a><span class="lineno">  387</span>&#160;    <span class="keywordtype">void</span> *mEchoReplyContext;</div><div class="line"><a name="l00388"></a><span class="lineno">  388</span>&#160;    <span class="keywordtype">bool</span> mIsEchoEnabled;</div><div class="line"><a name="l00389"></a><span class="lineno">  389</span>&#160;</div><div class="line"><a name="l00390"></a><span class="lineno">  390</span>&#160;    <a class="code" href="../../d3/d05/classThread_1_1Ip6_1_1Ip6.html">Ip6</a> &amp;mIp6;</div><div class="line"><a name="l00391"></a><span class="lineno">  391</span>&#160;};</div><div class="line"><a name="l00392"></a><span class="lineno">  392</span>&#160;</div><div class="line"><a name="l00398"></a><span class="lineno">  398</span>&#160;}  <span class="comment">// namespace Ip6</span></div><div class="line"><a name="l00399"></a><span class="lineno">  399</span>&#160;}  <span class="comment">// namespace Thread</span></div><div class="line"><a name="l00400"></a><span class="lineno">  400</span>&#160;</div><div class="line"><a name="l00401"></a><span class="lineno">  401</span>&#160;<span class="preprocessor">#endif  // NET_ICMP6_HPP_</span></div><div class="ttc" id="structThread_1_1Ip6_1_1IcmpHeaderPoD_html_a9340c0b6398ee6f072f20a6dac7983ce"><div class="ttname"><a href="../../d4/d90/structThread_1_1Ip6_1_1IcmpHeaderPoD.html#a9340c0b6398ee6f072f20a6dac7983ce">Thread::Ip6::IcmpHeaderPoD::mCode</a></div><div class="ttdeci">uint8_t mCode</div><div class="ttdoc">Code. </div><div class="ttdef"><b>Definition:</b> icmp6.hpp:68</div></div>
<div class="ttc" id="structThread_1_1Ip6_1_1IcmpHeaderPoD_html_a7964bba0309c888464566a609e566210"><div class="ttname"><a href="../../d4/d90/structThread_1_1Ip6_1_1IcmpHeaderPoD.html#a7964bba0309c888464566a609e566210">Thread::Ip6::IcmpHeaderPoD::mData</a></div><div class="ttdeci">union Thread::Ip6::IcmpHeaderPoD::@48 mData</div><div class="ttdoc">Message-specific data. </div></div>
<div class="ttc" id="classThread_1_1Ip6_1_1MessageInfo_html"><div class="ttname"><a href="../../da/d46/classThread_1_1Ip6_1_1MessageInfo.html">Thread::Ip6::MessageInfo</a></div><div class="ttdoc">This class implements message information for an IPv6 message. </div><div class="ttdef"><b>Definition:</b> socket.hpp:54</div></div>
<div class="ttc" id="classThread_1_1Ip6_1_1IcmpHeader_html_ad51a0764c274f4d82fd23a99fa1e6800"><div class="ttname"><a href="../../d2/de0/classThread_1_1Ip6_1_1IcmpHeader.html#ad51a0764c274f4d82fd23a99fa1e6800">Thread::Ip6::IcmpHeader::GetType</a></div><div class="ttdeci">Type GetType() const </div><div class="ttdoc">This method returns the ICMPv6 message type. </div><div class="ttdef"><b>Definition:</b> icmp6.hpp:109</div></div>
<div class="ttc" id="classThread_1_1Ip6_1_1Header_html"><div class="ttname"><a href="../../d8/d6e/classThread_1_1Ip6_1_1Header.html">Thread::Ip6::Header</a></div><div class="ttdoc">This class implements IPv6 header generation and parsing. </div><div class="ttdef"><b>Definition:</b> ip6_headers.hpp:132</div></div>
<div class="ttc" id="classThread_1_1Message_html"><div class="ttname"><a href="../../dc/d3c/classThread_1_1Message.html">Thread::Message</a></div><div class="ttdoc">This class represents a message. </div><div class="ttdef"><b>Definition:</b> message.hpp:213</div></div>
<div class="ttc" id="classThread_1_1Ip6_1_1IcmpHeader_html_a6e2af997154e86c8bb48118623c4ea8b"><div class="ttname"><a href="../../d2/de0/classThread_1_1Ip6_1_1IcmpHeader.html#a6e2af997154e86c8bb48118623c4ea8b">Thread::Ip6::IcmpHeader::SetChecksum</a></div><div class="ttdeci">void SetChecksum(uint16_t aChecksum)</div><div class="ttdoc">This method sets the ICMPv6 message checksum. </div><div class="ttdef"><b>Definition:</b> icmp6.hpp:157</div></div>
<div class="ttc" id="classThread_1_1Ip6_1_1IcmpHeader_html_a9939caba0638b495eb7a74bfc76120fb"><div class="ttname"><a href="../../d2/de0/classThread_1_1Ip6_1_1IcmpHeader.html#a9939caba0638b495eb7a74bfc76120fb">Thread::Ip6::IcmpHeader::Type</a></div><div class="ttdeci">Type</div><div class="ttdoc">ICMPv6 Message Types. </div><div class="ttdef"><b>Definition:</b> icmp6.hpp:96</div></div>
<div class="ttc" id="openthread-types_8h_html_ab701d053a9c34ab7f11e43e0dc09ac9f"><div class="ttname"><a href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a></div><div class="ttdeci">ThreadError</div><div class="ttdoc">This enumeration represents error codes used throughout OpenThread. </div><div class="ttdef"><b>Definition:</b> openthread-types.h:75</div></div>
<div class="ttc" id="structThread_1_1Ip6_1_1IcmpHeaderPoD_html_a1d3fc65dcc6b226759c2da5eb1f7422b"><div class="ttname"><a href="../../d4/d90/structThread_1_1Ip6_1_1IcmpHeaderPoD.html#a1d3fc65dcc6b226759c2da5eb1f7422b">Thread::Ip6::IcmpHeaderPoD::mType</a></div><div class="ttdeci">uint8_t mType</div><div class="ttdoc">Type. </div><div class="ttdef"><b>Definition:</b> icmp6.hpp:67</div></div>
<div class="ttc" id="classThread_1_1Ip6_1_1Ip6_html"><div class="ttname"><a href="../../d3/d05/classThread_1_1Ip6_1_1Ip6.html">Thread::Ip6::Ip6</a></div><div class="ttdoc">This class implements the core IPv6 message processing. </div><div class="ttdef"><b>Definition:</b> ip6.hpp:96</div></div>
<div class="ttc" id="classThread_1_1Ip6_1_1IcmpHeader_html_a9f4d328694de528770bce839e920f1ff"><div class="ttname"><a href="../../d2/de0/classThread_1_1Ip6_1_1IcmpHeader.html#a9f4d328694de528770bce839e920f1ff">Thread::Ip6::IcmpHeader::GetCode</a></div><div class="ttdeci">Code GetCode() const </div><div class="ttdoc">This method returns the ICMPv6 message code. </div><div class="ttdef"><b>Definition:</b> icmp6.hpp:134</div></div>
<div class="ttc" id="classThread_1_1Ip6_1_1IcmpHeader_html_af871471b8d84ee757ecd81483944373e"><div class="ttname"><a href="../../d2/de0/classThread_1_1Ip6_1_1IcmpHeader.html#af871471b8d84ee757ecd81483944373e">Thread::Ip6::IcmpHeader::SetCode</a></div><div class="ttdeci">void SetCode(Code aCode)</div><div class="ttdoc">This method sets the ICMPv6 message code. </div><div class="ttdef"><b>Definition:</b> icmp6.hpp:141</div></div>
<div class="ttc" id="structThread_1_1Ip6_1_1IcmpHeaderPoD_html"><div class="ttname"><a href="../../d4/d90/structThread_1_1Ip6_1_1IcmpHeaderPoD.html">Thread::Ip6::IcmpHeaderPoD</a></div><div class="ttdoc">This structure represents an ICMPv6 header. </div><div class="ttdef"><b>Definition:</b> icmp6.hpp:65</div></div>
<div class="ttc" id="classThread_1_1Ip6_1_1IcmpHeader_html"><div class="ttname"><a href="../../d2/de0/classThread_1_1Ip6_1_1IcmpHeader.html">Thread::Ip6::IcmpHeader</a></div><div class="ttdoc">This class implements ICMPv6 header generation and parsing. </div><div class="ttdef"><b>Definition:</b> icmp6.hpp:83</div></div>
<div class="ttc" id="encoding_8hpp_html"><div class="ttname"><a href="../../df/d57/encoding_8hpp.html">encoding.hpp</a></div><div class="ttdoc">This file includes definitions for byte-ordering encoding. </div></div>
<div class="ttc" id="classThread_1_1Ip6_1_1IcmpHandler_html"><div class="ttname"><a href="../../da/dff/classThread_1_1Ip6_1_1IcmpHandler.html">Thread::Ip6::IcmpHandler</a></div><div class="ttdoc">This class implements ICMPv6 message handlers. </div><div class="ttdef"><b>Definition:</b> icmp6.hpp:213</div></div>
<div class="ttc" id="classThread_1_1Ip6_1_1IcmpHeader_html_ad2fc6f420d783b7185bc11906d9d7bcf"><div class="ttname"><a href="../../d2/de0/classThread_1_1Ip6_1_1IcmpHeader.html#ad2fc6f420d783b7185bc11906d9d7bcf">Thread::Ip6::IcmpHeader::SetId</a></div><div class="ttdeci">void SetId(uint16_t aId)</div><div class="ttdoc">This method sets the ICMPv6 message ID for Echo Requests and Replies. </div><div class="ttdef"><b>Definition:</b> icmp6.hpp:173</div></div>
<div class="ttc" id="group__toolchain_html_gacf07d7a4a2ea6d0cc3426234565fcb7b"><div class="ttname"><a href="../../d7/da1/group__toolchain.html#gacf07d7a4a2ea6d0cc3426234565fcb7b">OT_TOOL_PACKED_END</a></div><div class="ttdeci">#define OT_TOOL_PACKED_END</div><div class="ttdoc">Compiler-specific indication at the end of a byte packed class or struct. </div><div class="ttdef"><b>Definition:</b> toolchain.h:131</div></div>
<div class="ttc" id="classThread_1_1Ip6_1_1Icmp_html"><div class="ttname"><a href="../../da/dd7/classThread_1_1Ip6_1_1Icmp.html">Thread::Ip6::Icmp</a></div><div class="ttdoc">This class implements ICMPv6. </div><div class="ttdef"><b>Definition:</b> icmp6.hpp:258</div></div>
<div class="ttc" id="classThread_1_1Ip6_1_1IcmpHeader_html_a8609c3839e26f6ab4625159bf9c35873"><div class="ttname"><a href="../../d2/de0/classThread_1_1Ip6_1_1IcmpHeader.html#a8609c3839e26f6ab4625159bf9c35873">Thread::Ip6::IcmpHeader::SetType</a></div><div class="ttdeci">void SetType(Type aType)</div><div class="ttdoc">This method sets the ICMPv6 message type. </div><div class="ttdef"><b>Definition:</b> icmp6.hpp:117</div></div>
<div class="ttc" id="classThread_1_1Ip6_1_1IcmpHandler_html_a0d479f55838901ccb5b1ebd383e20db4"><div class="ttname"><a href="../../da/dff/classThread_1_1Ip6_1_1IcmpHandler.html#a0d479f55838901ccb5b1ebd383e20db4">Thread::Ip6::IcmpHandler::IcmpHandler</a></div><div class="ttdeci">IcmpHandler(DstUnreachHandler aDstUnreachHandler, void *aContext)</div><div class="ttdoc">This constructor creates an ICMPv6 message handler. </div><div class="ttdef"><b>Definition:</b> icmp6.hpp:238</div></div>
<div class="ttc" id="structThread_1_1Ip6_1_1IcmpHeaderPoD_html_a1f9efcf2fc78902fe8dd520ae05fcea8"><div class="ttname"><a href="../../d4/d90/structThread_1_1Ip6_1_1IcmpHeaderPoD.html#a1f9efcf2fc78902fe8dd520ae05fcea8">Thread::Ip6::IcmpHeaderPoD::mChecksum</a></div><div class="ttdeci">uint16_t mChecksum</div><div class="ttdoc">Checksum. </div><div class="ttdef"><b>Definition:</b> icmp6.hpp:69</div></div>
<div class="ttc" id="classThread_1_1Ip6_1_1IcmpHeader_html_a036101271b93c88ed1cc7038c45bd163"><div class="ttname"><a href="../../d2/de0/classThread_1_1Ip6_1_1IcmpHeader.html#a036101271b93c88ed1cc7038c45bd163">Thread::Ip6::IcmpHeader::GetSequence</a></div><div class="ttdeci">uint16_t GetSequence() const </div><div class="ttdoc">This method returns the ICMPv6 message sequence for Echo Requests and Replies. </div><div class="ttdef"><b>Definition:</b> icmp6.hpp:181</div></div>
<div class="ttc" id="classThread_1_1Ip6_1_1IcmpHeader_html_aeda92e625e305e9021bc18ccadfba4ca"><div class="ttname"><a href="../../d2/de0/classThread_1_1Ip6_1_1IcmpHeader.html#aeda92e625e305e9021bc18ccadfba4ca">Thread::Ip6::IcmpHeader::GetChecksumOffset</a></div><div class="ttdeci">static uint8_t GetChecksumOffset()</div><div class="ttdoc">This static method returns the byte offset of the Checksum field in the ICMPv6 header. </div><div class="ttdef"><b>Definition:</b> icmp6.hpp:197</div></div>
<div class="ttc" id="ip6__headers_8hpp_html"><div class="ttname"><a href="../../db/d51/ip6__headers_8hpp.html">ip6_headers.hpp</a></div><div class="ttdoc">This file includes definitions for IPv6 packet processing. </div></div>
<div class="ttc" id="classThread_1_1Ip6_1_1IcmpHeader_html_a275fba913f341b9d0e7018b5e02e072a"><div class="ttname"><a href="../../d2/de0/classThread_1_1Ip6_1_1IcmpHeader.html#a275fba913f341b9d0e7018b5e02e072a">Thread::Ip6::IcmpHeader::SetSequence</a></div><div class="ttdeci">void SetSequence(uint16_t aSequence)</div><div class="ttdoc">This method sets the ICMPv6 message sequence for Echo Requests and Replies. </div><div class="ttdef"><b>Definition:</b> icmp6.hpp:189</div></div>
<div class="ttc" id="classThread_1_1Ip6_1_1IcmpHeader_html_a500827c838059c96ab7c1aea787a74fb"><div class="ttname"><a href="../../d2/de0/classThread_1_1Ip6_1_1IcmpHeader.html#a500827c838059c96ab7c1aea787a74fb">Thread::Ip6::IcmpHeader::GetDataOffset</a></div><div class="ttdeci">static uint8_t GetDataOffset()</div><div class="ttdoc">This static method returns the byte offset of the ICMPv6 payload. </div><div class="ttdef"><b>Definition:</b> icmp6.hpp:205</div></div>
<div class="ttc" id="classThread_1_1Ip6_1_1IcmpHeader_html_aef3c7da70d4b476884163996141a481b"><div class="ttname"><a href="../../d2/de0/classThread_1_1Ip6_1_1IcmpHeader.html#aef3c7da70d4b476884163996141a481b">Thread::Ip6::IcmpHeader::Init</a></div><div class="ttdeci">void Init()</div><div class="ttdoc">This method initializes the ICMPv6 header to all zeros. </div><div class="ttdef"><b>Definition:</b> icmp6.hpp:90</div></div>
<div class="ttc" id="group__toolchain_html_gaba6ad63129c3a790957a9b149a65891b"><div class="ttname"><a href="../../d7/da1/group__toolchain.html#gaba6ad63129c3a790957a9b149a65891b">OT_TOOL_PACKED_BEGIN</a></div><div class="ttdeci">#define OT_TOOL_PACKED_BEGIN</div><div class="ttdoc">Compiler-specific indication that a class or struct must be byte packed. </div><div class="ttdef"><b>Definition:</b> toolchain.h:129</div></div>
<div class="ttc" id="classThread_1_1Ip6_1_1IcmpHeader_html_ac2a08e3b5fc1a6cb6a1f2dead5403e02"><div class="ttname"><a href="../../d2/de0/classThread_1_1Ip6_1_1IcmpHeader.html#ac2a08e3b5fc1a6cb6a1f2dead5403e02">Thread::Ip6::IcmpHeader::Code</a></div><div class="ttdeci">Code</div><div class="ttdoc">ICMPv6 Message Codes. </div><div class="ttdef"><b>Definition:</b> icmp6.hpp:123</div></div>
<div class="ttc" id="namespaceThread_html"><div class="ttname"><a href="../../d9/d00/namespaceThread.html">Thread</a></div><div class="ttdef"><b>Definition:</b> cli.cpp:61</div></div>
<div class="ttc" id="classThread_1_1Ip6_1_1IcmpHeader_html_a027f2899206b74dad24b25d164163d37"><div class="ttname"><a href="../../d2/de0/classThread_1_1Ip6_1_1IcmpHeader.html#a027f2899206b74dad24b25d164163d37">Thread::Ip6::IcmpHeader::GetChecksum</a></div><div class="ttdeci">uint16_t GetChecksum() const </div><div class="ttdoc">This method returns the ICMPv6 message checksum. </div><div class="ttdef"><b>Definition:</b> icmp6.hpp:149</div></div>
<div class="ttc" id="classThread_1_1Ip6_1_1IcmpHeader_html_a85cd947dd4eb8f5ba2c2fbd8a09a564d"><div class="ttname"><a href="../../d2/de0/classThread_1_1Ip6_1_1IcmpHeader.html#a85cd947dd4eb8f5ba2c2fbd8a09a564d">Thread::Ip6::IcmpHeader::GetId</a></div><div class="ttdeci">uint16_t GetId() const </div><div class="ttdoc">This method returns the ICMPv6 message ID for Echo Requests and Replies. </div><div class="ttdef"><b>Definition:</b> icmp6.hpp:165</div></div>
<div class="ttc" id="classThread_1_1Ip6_1_1Address_html"><div class="ttname"><a href="../../d9/db1/classThread_1_1Ip6_1_1Address.html">Thread::Ip6::Address</a></div><div class="ttdoc">This class implements an IPv6 address object. </div><div class="ttdef"><b>Definition:</b> ip6_address.hpp:56</div></div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="../../dir_68267d1309a1af8e8297ef4c3efbcdba.html">src</a></li><li class="navelem"><a class="el" href="../../dir_aebb8dcc11953d78e620bbef0b9e2183.html">core</a></li><li class="navelem"><a class="el" href="../../dir_73cb4d11b06c10448caf49ed02a351c4.html">net</a></li><li class="navelem"><a class="el" href="../../d0/dba/icmp6_8hpp.html">icmp6.hpp</a></li>
    <li class="footer">Generated on Fri Oct 14 2016 08:44:33 for OpenThread by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="../../doxygen.png" alt="doxygen"/></a> 1.8.11 </li>
  </ul>
</div>
</body>
</html>
